// Code generated by goctl. DO NOT EDIT.

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	fsProductTemplateTagsFieldNames          = builder.RawFieldNames(&FsProductTemplateTags{})
	fsProductTemplateTagsRows                = strings.Join(fsProductTemplateTagsFieldNames, ",")
	fsProductTemplateTagsRowsExpectAutoSet   = strings.Join(stringx.Remove(fsProductTemplateTagsFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	fsProductTemplateTagsRowsWithPlaceHolder = strings.Join(stringx.Remove(fsProductTemplateTagsFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"
)

type (
	fsProductTemplateTagsModel interface {
		Insert(ctx context.Context, data *FsProductTemplateTags) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*FsProductTemplateTags, error)
		Update(ctx context.Context, data *FsProductTemplateTags) error
		Delete(ctx context.Context, id int64) error
	}

	defaultFsProductTemplateTagsModel struct {
		conn  sqlx.SqlConn
		table string
	}

	FsProductTemplateTags struct {
		Id       int64  `db:"id"`        // ID
		Title    string `db:"title"`     // 标题
		Status   int64  `db:"status"`    // 状态 1：可用
		CreateAt int64  `db:"create_at"` // 创建时间
	}
)

func newFsProductTemplateTagsModel(conn sqlx.SqlConn) *defaultFsProductTemplateTagsModel {
	return &defaultFsProductTemplateTagsModel{
		conn:  conn,
		table: "`fs_product_template_tags`",
	}
}

func (m *defaultFsProductTemplateTagsModel) Delete(ctx context.Context, id int64) error {
	query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
	_, err := m.conn.ExecCtx(ctx, query, id)
	return err
}

func (m *defaultFsProductTemplateTagsModel) FindOne(ctx context.Context, id int64) (*FsProductTemplateTags, error) {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", fsProductTemplateTagsRows, m.table)
	var resp FsProductTemplateTags
	err := m.conn.QueryRowCtx(ctx, &resp, query, id)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultFsProductTemplateTagsModel) Insert(ctx context.Context, data *FsProductTemplateTags) (sql.Result, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?)", m.table, fsProductTemplateTagsRowsExpectAutoSet)
	ret, err := m.conn.ExecCtx(ctx, query, data.Title, data.Status)
	return ret, err
}

func (m *defaultFsProductTemplateTagsModel) Update(ctx context.Context, data *FsProductTemplateTags) error {
	query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, fsProductTemplateTagsRowsWithPlaceHolder)
	_, err := m.conn.ExecCtx(ctx, query, data.Title, data.Status, data.Id)
	return err
}

func (m *defaultFsProductTemplateTagsModel) tableName() string {
	return m.table
}
